<script lang="ts">
import { ref } from "vue";
import { useRoute } from "vue-router";
import WalletService from "@/services/wallet.service";
import { useUserStore } from "@/stores/user";
import { generateOTP } from "@/crypto";
import os from "os";
export default {
  setup() {
    // access the `store` variable anywhere in the component ✨
    const userStore: any = useUserStore();
    const txData = ref(null);
    const index = ref(null);
    const applicationId = ref("");
    const identityId = ref({});
    const route = useRoute();
    const blocked = ref(false);
    let count = ref(0);

    console.log(userStore.data);

    let message: any = ref([]);
    if (route.query.applicationId && route.query.txData) {
      applicationId.value = route.query.applicationId;
      txData.value = route.query.txData;
    }
    const generateOTPNow = async () => {
      console.time("generateOTPNow");
      // txData.value = { data: txData.value, id: Date.now().toString() };
      userStore.data.userData.otp = await generateOTP(
        userStore.data.userData.id,
        userStore.data.userData.password,
        userStore.data.userData.privateKey,
        userStore.data.userData.publicKey,
        index.value,
        txData.value
      );
      userStore.data.userData.otp.transactionData = { data: txData.value, id: Date.now().toString() };
      console.timeEnd("generateOTPNow");
      const cpuUsage = os.cpus();
      console.log("CPU usage:", cpuUsage);
    };
    const submit = async () => {
      // let array = []
      // for (let index = 1; index < 1000; index++) {
      // txData.value = { data: "teste", id: Date.now().toString() }
      // userStore.data.userData.otp = await generateOTP(userStore.data.userData.id, userStore.data.userData.password, userStore.data.userData.privateKey, userStore.data.userData.publicKey, index, txData.value);
      // userStore.data.userData.otp.transactionData = txData.value;
      // array.push(userStore.data.userData.otp)
      // console.log(index);
      // }
      // console.log(array);

      // return;
      console.time("authenticate");
      blocked.value = true;
      await WalletService.postAuthenticate(userStore.data.userData.otp).then(
        async (response: any) => {
          message.value = [
            {
              severity: "success",
              content: "Transação enviada.",
              id: count.value++,
            },
          ];
          blocked.value = false;

          console.timeEnd("authenticate");
          const cpuUsage = os.cpus();
          console.log("CPU usage:", cpuUsage);
        },
        (err: any) => {
          blocked.value = false;
          console.log(err);
          console.log("error");
          if (!err.response) {
            message.value = [
              {
                severity: "error",
                content: err.message,
                id: count.value++,
              },
            ];
          } else {
            message.value = [
              {
                severity: "error",
                content: err.response.data.message,
                id: count.value++,
              },
            ];
          }
        }
      );
    };
    return {
      submit,
      generateOTPNow,
      blocked,
      applicationId,
      txData,
      count,
      identityId,
      userStore,
      message,
      index,
    };
  },
};
</script>

<template>
  <ProgressSpinner
    v-if="blocked"
    style="width: 50px; height: 50px"
    strokeWidth="6"
    fill="var(--surface-ground)"
    animationDuration=".5s"
    aria-label="Custom ProgressSpinner"
  />

  <Message v-for="msg of message" :severity="msg.severity" :key="msg.id">{{
    msg.content
  }}</Message>
  <BlockUI :blocked="blocked">
    <div class="greetings">
      <h1>Enviar Transação</h1>
    </div>
          <Card>
            <template #title> Seus dados: </template>
            <template #content>
              <p>
                Chave Privada:
                {{ userStore.data.userData ? userStore.data.userData.privateKey.substring(32, 40) : "" }}...
              </p>
              <p>
                Chave Pública:
                {{ userStore.data.userData ? userStore.data.userData.publicKey.substring(32, 40) : "" }}...
              </p>
              <p>
                Index Atual:
                {{
                  userStore.data.userData.otp
                    ? userStore.data.userData.otp.index
                    : ""
                }}
              </p>
              <p>
                Token Atual:
                {{
                  userStore.data.userData.otp
                    ? userStore.data.userData.otp.OTP.substring(0, 10)
                    : ""
                }}...
              </p>
              <p>
                Próximo Token:
                {{
                  userStore.data.userData.otp
                    ? userStore.data.userData.otp.nextOTPHash.substring(0, 10)
                    : ""
                }}...
              </p>
              <p>
                Messagem Assinada:
                {{
                  userStore.data.userData.otp
                    ? userStore.data.userData.otp.signedMessage.substring(0, 10)
                    : ""
                }}...
              </p>
            </template>
          </Card>
    <div class="grid p-fluid">
      <br />
      <div class="p-fluid">
        <div>
          <div>
          <label>Index do Token</label>
            <InputNumber
              id="index"
              type="number"
              class="p-inputtext-lg"
              v-model="index"
              placeholder="Digite o index"
            />
          </div>
          <br />
        <div>
          <label>Dados da Transação</label>
          <InputText
            id="txData"
            type="text"
            class="p-inputtext-lg"
            v-model="txData"
            placeholder="Digite os dados da transação"
          />
        </div>
        Transação:
        {{ userStore.data.userData.otp ? userStore.data.userData.otp.transactionData : "" }}
        <br/>
        </div>
      </div>
      <br />
      <div>
              <Button
                label="1. Gerar Token"
                @click="generateOTPNow()"
              />
      </div>
      <br />
      <div>
        <Button label="2. Enviar" @click="submit()" />
      </div>
      
    </div>
  </BlockUI>
</template>
<style>
@media (min-width: 1024px) {
  .enroll {
    min-height: 100vh;
    display: flex;
    align-items: center;
  }
}

.p-fluid .p-fileupload .p-button {
  width: 100%;
}
</style>
